const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const system_parameters = sequelize.define(
    'system_parameters',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

key: {
        type: DataTypes.TEXT,
      
      

      },

value: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

lastUpdatedAt: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  system_parameters.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity













































//end loop



    db.system_parameters.belongsTo(db.users, {
      as: 'lastUpdatedByUser',
      foreignKey: {
        name: 'lastUpdatedByUserId',
      },
      constraints: false,
    });




    db.system_parameters.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.system_parameters.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return system_parameters;
};


